Subject: Re: [PATCH iwl-next v2 0/4] igb: XDP/ZC follow up

From: Kurt Kanzenbach <[email-masked]>
Date: Thu, 20 Feb 2025 08:44:51 +0100

On Wed Feb 19 2025, Joe Damato wrote:
> On Wed, Feb 19, 2025 at 03:03:36PM +0100, Kurt Kanzenbach wrote:
>> On Tue Feb 18 2025, Joe Damato wrote:
>> > On Tue, Feb 18, 2025 at 04:18:19PM -0500, Joe Damato wrote:
>> >> On Mon, Feb 17, 2025 at 12:31:20PM +0100, Kurt Kanzenbach wrote:
>> >> > This is a follow up for the igb XDP/ZC implementation. The first two 
>> >> > patches link the IRQs and queues to NAPI instances. This is required to 
>> >> > bring back the XDP/ZC busy polling support. The last patch removes 
>> >> > undesired IRQs (injected via igb watchdog) while busy polling with 
>> >> > napi_defer_hard_irqs and gro_flush_timeout set.
>> >> > 
>> >> > Signed-off-by: Kurt Kanzenbach <[email-masked]>
>> >> > ---
>> >> > Changes in v2:
>> >> > - Take RTNL lock in PCI error handlers (Joe)
>> >> > - Fix typo in commit message (Gerhard)
>> >> > - Use netif_napi_add_config() (Joe)
>> >> > - Link to v1: https://lore.kernel.org/r/[email-masked]
>> >> 
>> >> Thanks for sending a v2.
>> >> 
>> >> My comment from the previous series still stands, which simply that
>> >> I have no idea if the maintainers will accept changes using this API
>> >> or prefer to wait until Stanislav's work [1] is completed to remove
>> >> the RTNL requirement from this API altogether.
>> >
>> > Also, may be worth running the newly added XSK test with the NETIF
>> > env var set to the igb device? Assuming eth0 is your igb device:
>> >
>> >   NETIF=eth0 ./tools/testing/selftests/drivers/net/queues.py
>> >
>> > should output:
>> >
>> >   KTAP version 1
>> >   1..4
>> >   ok 1 queues.get_queues
>> >   ok 2 queues.addremove_queues
>> >   ok 3 queues.check_down
>> >   ok 4 queues.check_xdp
>> >   # Totals: pass:4 fail:0 xfail:0 xpass:0 skip:0 error:0
>> >
>> > Note the check_xdp line above.
>> >
>> 
>> Sure, why not. Seems to work.
>
> Thanks for testing it.
>  
>> |root@apl1:~/linux# uname -a
>> |Linux apl1 6.14.0-rc2+ #2 SMP PREEMPT_RT Wed Feb 19 14:41:23 CET 2025 x86_64 GNU/Linux
>> |root@apl1:~/linux# NETIF=enp2s0 ./tools/testing/selftests/drivers/net/queues.py
>> |KTAP version 1
>> |1..4
>> |ok 1 queues.get_queues
>> |ok 2 queues.addremove_queues
>> |ok 3 queues.check_down
>> |ok 4 queues.check_xdp
>> |# Totals: pass:4 fail:0 xfail:0 xpass:0 skip:0 error:0
>> 
>> Has this xsk netlink attribute been added fairly recently? The test
>> failed on my kernel from a few days ago (kernel from today works).
>
> Yes, it was just merged, see the commit date here:
>
> https://git.kernel.org/pub/scm/linux/kernel/git/netdev/net-next.git/commit/?id=788e52e2b66844301fe09f3372d46d8c62f6ebe4
>
>> I think there's room for improvement though:
>> 
>> |root@apl1:~/linux# NETIF=enp2s0 ./tools/testing/selftests/drivers/net/queues.py
>> |KTAP version 1
>> |1..4
>> |ok 1 queues.get_queues
>> |ok 2 queues.addremove_queues
>> |ok 3 queues.check_down
>> |# Exception| Traceback (most recent call last):
>> |# Exception|   File "/root/linux/tools/testing/selftests/net/lib/py/ksft.py", line 218, in ksft_run
>> |# Exception|     case(*args)
>> |# Exception|   File "/root/linux/./tools/testing/selftests/drivers/net/queues.py", line 53, in check_xdp
>> |# Exception|     ksft_eq(q['xsk'], {})
>> |# Exception|             ~^^^^^^^
>> |# Exception| KeyError: 'xsk'
>> |not ok 4 queues.check_xdp
>> |# Totals: pass:3 fail:1 xfail:0 xpass:0 skip:0 error:0
>> 
>> I'd assume this shouldn't be a Python exception, but rather say
>> something like "Expected xsk attribute, but none found. Fix the driver!" :)
>> 
>> While at it would you mind to add a newline to the xdp_helper usage
>> line (and fix the one typo)?
>
> Jakub currently has a series out to change the test a bit and
> improve it overall, see:
>
>   https://lore.kernel.org/netdev/[email-masked]/
>

Great that Jakub is already on it. I've replied in that thread. Thanks.